
HealPointsGems = {
};

HealPointsGems.gems = {
  brilliantDawnstone = {
    name = "Brilliant Dawnstone",
    desc = "+8 Intellect",
    color = "yellow",
    stats = {
      INT = 8,
    }
  },
  dazzlingTalasite = {
    name = "Dazzling Talasite",
    desc = "+4 Intellect and +2 Mana every 5 seconds",
    color = "green",
    stats = {
      INT = 4,
      MANAREG = 2,
    }
  },
  gleamingDawnstone = {
    name = "Gleaming Dawnstone",
    desc = "+8 Spell Critical Rating",
    color = "yellow",
    stats = {
      SPELLCRITRATING = 8,
    }
  },
  glowingNightseye = {
    name = "Glowing Nightseye",
    desc = "+5 Spell Damage and +6 Stamina",
    color = "purple",
    stats = {
      HEAL = 5,
    }
  },
  infusedNightseye = {
    name = "Infused Nightseye",
    desc = "+8 Attack Power and +2 Mana every 5 seconds",
    color = "purple",
    stats = {
      MANAREG = 2,
    }
  },
  luminousNobleTopaz = {
    name = "Luminous Noble Topaz",
    desc = "+9 Healing Spells and +4 Intellect",
    color = "orange",
    stats = {
      HEAL = 9,
      INT = 4,
    }
  },
  lustrousStarOfElune = {
    name = "Lustrous Star of Elune",
    desc = "+3 Mana every 5 seconds",
    color = "blue",
    stats = {
      MANAREG = 3,
    }
  },
  potentNobleTopaz = {
    name = "Potent Noble Topaz",
    desc = "+4 Spell Critical Rating and +5 Spell Damage",
    color = "orange",
    stats = {
      SPELLCRITRATING = 4,
      HEAL = 5,
    }
  },
  purifiedShadowPearl = {
    name = "Purified Shadow Pearl",
    desc = "+9 Healing and +4 Spirit",
    color = "purple",
    stats = {
      HEAL = 9,
      SPI = 4,
    }
  },
  royalNightseye = {
    name = "Royal Nightseye",
    desc = "+9 Healing Spells and +2 Mana every 5 seconds",
    color = "purple",
    stats = {
      HEAL = 9,
      MANAREG = 2,
    }
  },
  runedLivingRuby = {
    name = "Runed Living Ruby",
    desc = "+9 Spell Damage",
    color = "red",
    stats = {
      HEAL = 9,
    }
  },
  sparklingStarOfElune = {
    name = "Sparkling Star of Elune",
    desc = "+8 Spirit",
    color = "blue",
    stats = {
      SPI = 8,
    }
  },
  teardropLivingRuby = {
    name = "Teardrop Living Ruby",
    desc = "+18 Healing",
    color = "red",
    stats = {
      HEAL = 18,
    }
  },
}

function HealPointsGems:setBlue(gemNumber)
  HealPoints:clearLinkCache();
  HealPoints.db.char.gems.blueGem = gemNumber;
end

function HealPointsGems:getBlue(gemNumber)
  return HealPoints.db.char.gems.blueGem == gemNumber;
end

function HealPointsGems:setRed(gemNumber)
  HealPoints:clearLinkCache();
  HealPoints.db.char.gems.redGem = gemNumber;
end

function HealPointsGems:getRed(gemNumber)
  return HealPoints.db.char.gems.redGem == gemNumber;
end

function HealPointsGems:setYellow(gemNumber)
  HealPoints:clearLinkCache();
  HealPoints.db.char.gems.yellowGem = gemNumber;
end

function HealPointsGems:getYellow(gemNumber)
  return HealPoints.db.char.gems.yellowGem == gemNumber;
end

function HealPointsGems:getBlueSelected()
  local number = HealPoints.db.char.gems.blueGem;
  local i, menu;
  for i, menu in pairs(HealPointsGems.blueSocket) do
    if (menu.passValue == number) then
      if (menu.gem == nil) then
        return nil;
      else
        return menu.gem.stats;
      end;
    end;
  end;
  return nil;
end

function HealPointsGems:getRedSelected()
  local number = HealPoints.db.char.gems.redGem;
  local i, menu;
  for i, menu in pairs(HealPointsGems.redSocket) do
    if (menu.passValue == number) then
      if (menu.gem == nil) then
        return nil;
      else
        return menu.gem.stats;
      end;
    end;
  end;
  return nil;
end

function HealPointsGems:getYellowSelected()
  local number = HealPoints.db.char.gems.yellowGem;
  local i, menu;
  for i, menu in pairs(HealPointsGems.yellowSocket) do
    if (menu.passValue == number) then
      if (menu.gem == nil) then
        return nil;
      else
        return menu.gem.stats;
      end;
    end;
  end;
  return nil;
end

local function gemToMenu(color, gemNumber, gem)
  menu = {
    type = "toggle",
    name = gem.name,
    desc = gem.desc, 
    get = "get"..color,
    set = "set"..color,
    passValue = gemNumber,
    handler = HealPointsGems,
    isRadio = true,
    gem = gem
  };
  return menu;
end

HealPointsGems.blueSocket = {
  none = {
    type = "toggle",
    name = "None",
    desc = "None",
    get = "getBlue",
    set = "setBlue",
    passValue = 1;
    handler = HealPointsGems,
    isRadio = true,
    order = 1,
  },
  gemToMenu("Blue", 2, HealPointsGems.gems.dazzlingTalasite),
  gemToMenu("Blue", 3, HealPointsGems.gems.glowingNightseye),
  gemToMenu("Blue", 4, HealPointsGems.gems.infusedNightseye),
  gemToMenu("Blue", 5, HealPointsGems.gems.lustrousStarOfElune),
  gemToMenu("Blue", 6, HealPointsGems.gems.purifiedShadowPearl),
  gemToMenu("Blue", 7, HealPointsGems.gems.royalNightseye),
  gemToMenu("Blue", 8, HealPointsGems.gems.sparklingStarOfElune),
}

HealPointsGems.redSocket = {
  none = {
    type = "toggle",
    name = "None",
    desc = "None",
    get = "getRed",
    set = "setRed",
    passValue = 1;
    handler = HealPointsGems,
    isRadio = true,
    order = 1,
  },
  gemToMenu("Red", 2, HealPointsGems.gems.glowingNightseye),
  gemToMenu("Red", 3, HealPointsGems.gems.infusedNightseye),
  gemToMenu("Red", 4, HealPointsGems.gems.luminousNobleTopaz),
  gemToMenu("Red", 5, HealPointsGems.gems.potentNobleTopaz),
  gemToMenu("Red", 6, HealPointsGems.gems.purifiedShadowPearl),
  gemToMenu("Red", 7, HealPointsGems.gems.royalNightseye),
  gemToMenu("Red", 8, HealPointsGems.gems.runedLivingRuby),
  gemToMenu("Red", 9, HealPointsGems.gems.teardropLivingRuby),
}

HealPointsGems.yellowSocket = {
  none = {
    type = "toggle",
    name = "None",
    desc = "None",
    get = "getYellow",
    set = "setYellow",
    passValue = 1;
    handler = HealPointsGems,
    isRadio = true,
    order = 1,
  },
  gemToMenu("Yellow", 2, HealPointsGems.gems.brilliantDawnstone),
  gemToMenu("Yellow", 3, HealPointsGems.gems.dazzlingTalasite),
  gemToMenu("Yellow", 4, HealPointsGems.gems.gleamingDawnstone),
  gemToMenu("Yellow", 5, HealPointsGems.gems.luminousNobleTopaz),
  gemToMenu("Yellow", 6, HealPointsGems.gems.potentNobleTopaz),
}

